<?php

namespace Drupal\mcapi_limits\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'dynamic entity reference label' formatter.
 *
 * @FieldFormatter(
 *   id = "mcapi_limits",
 *   label = @Translation("Limits"),
 *   field_types = {
 *     "mc_wallet_limits"
 *   }
 * )
 */
class LimitsFormatter extends FormatterBase {

  /**
   * {@inheritDoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [
      '#type' => 'item',
      '#markup' => t('Max: @max', ['@max' => Functions::formatCurrency($items->max())]) .
        '<br />' .
        t('Min: @min', ['@min' => Functions::formatCurrency($items->min())])
    ];
    return $elements;
  }
}
