<?php

namespace Drupal\mcapi_limits\Plugin\Field\FieldWidget;

use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the wallet selector widget.
 *
 * @FieldWidget(
 *   id = "mcapi_limits",
 *   label = @Translation("Limits"),
 *   description = @Translation("Fix the wallets min & max balance limits"),
 *   field_types = {
 *     "mc_wallet_limits"
 *   }
 * )
 */
class LimitsWidget extends WidgetBase {

  /**
   * {@inheritDoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element = [
      '#type' => 'minmax',
      '#default_value' => $items->getValue()[$delta], // Not quite how its supposed to be...
      // Show the amount as determined by the Currency settings.
      '#placeholder' => $items->getBaseLimits()
    ];
    return $element;
  }

  public function massageFormValues(array $values, array $form, FormStateInterface $form_state): array {
    $values[0]['min'] *= -1;
    return $values;
  }

}
