<?php

namespace Drupal\mcapi_limits\Plugin\Field;

use Drupal\Core\Field\FieldItemList;

/**
 * Methods for the limits FieldItemList.
 */
class LimitsFieldItemList extends FieldItemList {

  function getBaseLimits() {
    $config = \Drupal::config('mcapi_limits.settings');
    if ($plugin_id = $config->get('plugin')) {
      return \Drupal::service('plugin.manager.mcapi_limits')
        ->createInstance($plugin_id, $config->get('plugin_settings'))
        ->getLimits($this->getEntity());
    }
    return ['min' => NULL, 'max' => NULL];
  }

  /**
   * Get the minimum allowed balance for this wallet.
   */
  function min() {
    if ($this->min <> NULL) return $this->min;
    return $this->getBaseLimits()['min'];
  }

  /**
   * Get the maximum allowed balance for this wallet
   */
  function max() {
    if ($this->max <> NULL) return $this->max;
    return $this->getBaseLimits()['max'];
  }

}
