<?php

namespace Drupal\mcapi_limits;

use Drupal\mcapi\Entity\WalletInterface;
use Drupal\mcapi\Entity\TransactionInterface;

/**
 * Holds data for a transgression of balance limits.
 */
abstract class Transgression {

  /**
   * The wallet we are working with.
   * @var \Drupal\mcapi\Entity\Wallet
   */
  public $wallet;

  /**
   * The transaction we are working with.
   * @var \Drupal\mcapi\Entity\Transaction
   */
  public $transaction;

  /**
   * The limit of the account  in base units
   * @var int
   */
  public $limit;

  /**
   * The amount transgressed  in base units
   * @var int
   */
  public $diff;

  /**
   * The the excessive balance in base units
   * @var int
   */
  public $projected;

  /**
   * The the actual balance  in base units
   * @var int
   */
  public $balance;

  /**
   * Constructor.
   */
  public function __construct(TransactionInterface $transaction, WalletInterface $wallet, int $balance, int $limit, int $projected) {
    $this->transaction = $transaction;
    $this->wallet = $wallet;
    $this->projected = $projected;
    $this->limit = $limit;
    $this->diff = $projected - $limit;
    $this->balance = $wallet->getStat('balance');
  }

}
