<?php

namespace Drupal\mcapi\Element;

use Drupal\mcapi\Entity\Storage\WalletStorage;
use Drupal\user\Entity\User;
use Drupal\Core\Render\Element\Radios;
use Drupal\Core\Form\FormStateInterface;
/**
 * Form element to select the wallet to trade from. Hidden if only wallet is available.
 *
 * @RenderElement("my_wallet")
 */
class MyWallet extends Radios {

  /**
   * {@inheritDoc}
   */
  public static function processRadios(&$element, FormStateInterface $form_state, &$complete_form) {
    $user = User::load(\Drupal::currentuser()->id());
    $wallets = WalletStorage::walletsOf($user, TRUE);
    if (count($wallets) > 1) {
      foreach ($wallets as $w) {
        $element['#options'][$w->id()] = $w->label();
      }
      $element['#title'] = 'My wallet';
      $element['#weight'] = -1;
      return parent::processRadios($element, $form_state, $complete_form);
    }
    else {
      return [
        '#name' => $element['#name'],
        '#type' => 'hidden', // value doesn't seem to work.
        '#value' => reset($wallets)->id()
      ];
    }
  }

  /**
   * {@inheritDoc}
   */
  public static function preRenderCompositeFormElement($element) {
    $element = parent::preRenderCompositeFormElement($element);
    $element['#theme_wrappers'] = [];
    return $element;
  }

}
