<?php

namespace Drupal\mcapi\Element;

use Drupal\Core\Entity\Element\EntityAutocomplete;
use Drupal\Core\Form\FormStateInterface;
use Drupal\mcapi\Entity\Wallet;

/**
 * Provides a widget to select wallet references by name, using autocomplete.
 *
 * Its really just EntityAutocomplete with a lot of defaults.
 *
 * @FormElement("wallet_entity_auto")
 */
class WalletAutocomplete extends EntityAutocomplete {

  static $multiple;

  /**
   * {@inheritDoc}
   */
  public function getInfo() {
    $info = parent::getInfo();
    $info['#selection_handler'] = 'default:mc_wallet';
    $info['#target_type'] = 'mc_wallet';
    $info['#restrict'] = '';
    $info['#exclude'] = [];
    $info['#hidden'] = FALSE;
    $info['#maxlength'] = 64;
    // Appearance should be managed with css.
    $info['#size'] = 60;
    return $info;
  }

}
