<?php

namespace Drupal\mcapi\Entity\ListBuilder;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;
use Drupal\Core\Render\Markup;

/**
 * Defines a class to build a listing of Workflow config entities.
 *
 */
class TypeListBuilder extends EntityListBuilder {

  /**
   * {@inheritDoc}
   */
  public function buildHeader() {
    // Enable language column and filter if multiple languages are added.
    $header = [
      'name' => [
        'data' => $this->t('Name & summary')
      ],
      'scope' => $this->t('Scope'),
      'operations' => $this->t('Operations'),
    ];
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritDoc}
   */
  public function buildRow(EntityInterface $entity) {
    $row['name']['data'] = [
      '#markup' => Markup::Create($entity->label() . ': '.$entity->summary)
    ];
    // @todo in fact scopes can be anything from trunk to the twig
    $row['scope']['data'] = [
      '#markup' => $entity->local ? t('Local') : t('Remote')
    ];
    if ($entity->disabled) {
      $row['name']['data']['#prefix'] = '<font color=gray>';
      $row['name']['data']['#suffix'] = '</font>';
    }
    else {
      $row += parent::buildRow($entity);
    }
    return $row;
  }

}
