<?php

namespace Drupal\mcapi\Entity\Query;

use Drupal\Core\Entity\Query\Sql\Query as BaseQuery;
use Drupal\Core\Entity\ContentEntityInterface;

/**
 * The SQL storage entity query class.
 *
 * Extended to handle new methods to filter by wallets and wallet holders
 */
class TransactionQuery extends BaseQuery {

  /**
   * Filter the entityQuery to include only transactions in which the given
   * entity is payer or payee
   *
   * @param ContentEntityInterface $entity
   * @return \Drupal\mcapi\Entity\TransactionQuery
   */
  public function involving(int $wallet_id) {
    $group = $this->orConditionGroup()
      ->condition('entries.payer', $wallet_id)
      ->condition('entries.payee', $wallet_id);
    $this->condition($group);
    return $this;
  }

  public function noChildren() {
    $this->condition('entries.primary', '0');
    return $this;
  }

}

