<?php

namespace Drupal\mcapi\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\RevisionableInterface;
use Drupal\mcapi\Plugin\Field\FieldType\EntryItem;

/**
 * Interface for Transaction entity.
 */
interface TransactionInterface extends ContentEntityInterface, RevisionableInterface {

  /**
   * These enable the transaction to be filtered during the assemble and validation phases.
   * They are not saved.
   *
   * @todo refactor these.
   */
  const CREATION_CONTEXT_DEFAULT = 'default';
  const CREATION_CONTEXT_DESIGNED = 'designed';
  const CREATION_CONTEXT_MASS = 'mass';
  const CREATION_CONTEXT_AUTO = 'auto';


  public function addEntry(array $params) : EntryItem|NULL;


  public function allWallets() : array;


  static function states() : array;
}
