<?php

/**
 * @file
 */
namespace Drupal\mcapi\Plugin\migrate\process;

use Drupal\migrate\MigrateExecutableInterface;
use Drupal\migrate\ProcessPluginBase;
use Drupal\migrate\Row;

/**
 * convert the old display setting into the new one-string format
 *
 * @MigrateProcessPlugin(
 *   id = "mc_workflow"
 * )
 */
class TransactionType extends ProcessPluginBase {

  /**
   * {@inheritDoc}
   *
   * $value must be a workflow type i.e 3rdparty, default_bill, default_credit.
   */
  public function transform($value, MigrateExecutableInterface $migrate_executable, Row $row, $destination_property) {
     \Drupal::moduleHandler()->loadInclude('mcapi', 'install') ;
    return mcapi_type_update(
      $row->getSource('type'),
      $row->getSource('payee'),
      $row->getSource('payer'),
      $row->getSource('creator')
    );
  }

}
