<?php

namespace Drupal\mcapi\Plugin\views\field;

use Drupal\mcapi\Entity\Storage\WalletStorage;
use Drupal\views\ResultRow;
use Drupal\views\Plugin\views\field\FieldPluginBase;
use Drupal\Core\Render\Markup;

/**
 * Field handler provides current stat for given wallet via Wallet::getStatAll.
 *
 * @ingroup views_field_handlers
 *
 * @ViewsField("wallet_stat")
 */
class WalletStat extends FieldPluginBase {

  /**
   * {@inheritDoc}
   */
  public function query() {
    $this->addAdditionalFields();
  }

  /**
   * {@inheritDoc}
   */
  public function render(ResultRow $values) {
    $entity = $this->getEntity($values);
    if ($entity->getEntityTypeId() != 'mc_wallet') {
      $entities = WalletStorage::walletsOf($entity, TRUE);
      $wallet = reset($entities);
    }
    else {
      $wallet = $entity;
    }
    if ($wallet) {
      $stat = $this->definition['stat'];
      return Markup::create($wallet->{$stat});
    }
  }

}
